=== debian/changelog ===
miniupnpc (2.2.3-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 18:49:17 +0000

miniupnpc (2.2.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.0.

 -- Yangfl <mmyangfl@gmail.com>  Sun, 03 Oct 2021 13:50:34 +0800
