=== debian/changelog ===
miniupnpc (2.2.4-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.2.

 -- Yangfl <mmyangfl@gmail.com>  Thu, 22 Dec 2022 00:58:18 +0800

miniupnpc (2.2.3-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Add missing Build-Depends: libpython3-dev (Closes: #1002074).

 -- Thomas Goirand <zigo@debian.org>  Mon, 12 Dec 2022 13:43:01 +0100
