=== debian/control ===
--- 
+++ 
@@ -7,11 +7,12 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-python,
+ libpython3-dev,
  python3-dev:any,
  python3-setuptools,
  net-tools,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/miniupnp-team/miniupnpc
 Vcs-Git: https://salsa.debian.org/miniupnp-team/miniupnpc.git
 Homepage: http://miniupnp.free.fr/
@@ -60,8 +61,7 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends}, libminiupnpc17 (= ${binary:Version})
-Breaks: miniupnpc (<< 2.0)
-Replaces: libminiupnpc5, libminiupnpc8, libminiupnpc10, libminiupnpc16, miniupnpc (<< 2.0)
+Replaces: libminiupnpc5, libminiupnpc8, libminiupnpc10, libminiupnpc16
 Multi-Arch: same
 Description: UPnP IGD client lightweight library development files
  The UPnP protocol is supported by most home adsl/cable routers and Microsoft
