## miniupnpc 2.2.5

=== debian/changelog ===
miniupnpc (2.2.5-1) unstable; urgency=medium

  * New upstream release.

 -- Yangfl <mmyangfl@gmail.com>  Sat, 05 Aug 2023 14:18:18 +0800
