## miniupnpc 2.2.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.12 FATAL_ERROR)
 
 project (miniupnpc
-         VERSION 2.2.3
+         VERSION 2.2.6
          DESCRIPTION "UPnP IGD client lightweight library"
          HOMEPAGE_URL https://miniupnp.tuxfamily.org/
          LANGUAGES C)
@@ -36,8 +36,14 @@
     # add_definitions (-D_POSIX_C_SOURCE=200112L)
     target_compile_definitions(miniupnpc-private INTERFACE _XOPEN_SOURCE=600)
   endif ()
+  if (CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
+    target_compile_definitions(miniupnpc-private INTERFACE _NETBSD_SOURCE)
+  endif ()
 else ()
-  target_compile_definitions(miniupnpc-private INTERFACE _WIN32_WINNT=0x0501) # XP or higher for getnameinfo and friends
+  set (MINIUPNPC_TARGET_WINDOWS_VERSION "0x0501" CACHE STRING "Minimum target Windows version as hex string") # XP or higher for getnameinfo and friends
+  if (MINIUPNPC_TARGET_WINDOWS_VERSION)
+    target_compile_definitions(miniupnpc-private INTERFACE _WIN32_WINNT=${MINIUPNPC_TARGET_WINDOWS_VERSION})
+  endif ()
 endif ()
 
 if (APPLE)
@@ -133,7 +139,19 @@
     add_executable (upnpc-static src/upnpc.c)
     target_link_libraries (upnpc-static PRIVATE libminiupnpc-static)
     target_include_directories(upnpc-static PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
-  endif ()
+    if (NOT UPNPC_NO_INSTALL)
+      install (TARGETS upnpc-static
+               RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+    endif()
+  endif ()
+
+  add_executable (upnp-listdevices-static src/listdevices.c)
+  target_link_libraries (upnp-listdevices-static PRIVATE libminiupnpc-static)
+  target_include_directories(upnp-listdevices-static PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
+  if (NOT UPNPC_NO_INSTALL)
+    install (TARGETS upnp-listdevices-static
+             RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+  endif()
 endif ()
 
 if (UPNPC_BUILD_SHARED)
@@ -170,11 +188,19 @@
     add_executable (upnpc-shared src/upnpc.c)
     target_link_libraries (upnpc-shared PRIVATE libminiupnpc-shared)
     target_include_directories(upnpc-shared PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
-  endif ()
-
-  add_executable (listdevices src/listdevices.c)
-  target_link_libraries (listdevices PRIVATE libminiupnpc-shared)
-  target_include_directories(listdevices PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
+    if (NOT UPNPC_NO_INSTALL)
+      install (TARGETS upnpc-shared
+               RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+    endif()
+  endif ()
+
+  add_executable (upnp-listdevices-shared src/listdevices.c)
+  target_link_libraries (upnp-listdevices-shared PRIVATE libminiupnpc-shared)
+  target_include_directories(upnp-listdevices-shared PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
+  if (NOT UPNPC_NO_INSTALL)
+    install (TARGETS upnp-listdevices-shared
+             RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+  endif()
 endif ()
 
 if (UPNPC_BUILD_TESTS)
@@ -225,7 +251,9 @@
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>)
   target_link_libraries (testportlistingparse PRIVATE miniupnpc-tests)
 
-  add_executable (minihttptestserver src/minihttptestserver.c)
+  if (NOT WIN32)
+    add_executable (minihttptestserver src/minihttptestserver.c)
+  endif()
 
 # set (UPNPC_INSTALL_TARGETS ${UPNPC_INSTALL_TARGETS} testminixml minixmlvalid testupnpreplyparse testigddescparse testminiwget)
   include(CTest)
@@ -233,10 +261,12 @@
            COMMAND minixmlvalid)
   add_test(NAME validateminiwget
            COMMAND ${CMAKE_SOURCE_DIR}/testminiwget.sh)
-  set_property(TEST validateminiwget
-               PROPERTY ENVIRONMENT
-               TESTSERVER=${CMAKE_BINARY_DIR}/minihttptestserver
-               TESTMINIWGET=${CMAKE_BINARY_DIR}/testminiwget)
+  if (NOT WIN32)
+    set_property(TEST validateminiwget
+                 PROPERTY ENVIRONMENT
+                 TESTSERVER=${CMAKE_BINARY_DIR}/minihttptestserver
+                 TESTMINIWGET=${CMAKE_BINARY_DIR}/testminiwget)
+  endif()
   add_test(NAME validateupnpreplyparse
            COMMAND ${CMAKE_SOURCE_DIR}/testupnpreplyparse.sh
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
@@ -256,30 +286,3 @@
 
 endif ()
 
-configure_file(miniupnpc.pc.in miniupnpc.pc @ONLY)
-
-if (NOT UPNPC_NO_INSTALL)
-  install (FILES
-    include/miniupnpc.h
-    include/miniwget.h
-    include/upnpcommands.h
-    include/igd_desc_parse.h
-    include/upnpreplyparse.h
-    include/upnperrors.h
-    include/upnpdev.h
-    include/miniupnpctypes.h
-    include/portlistingparse.h
-    include/miniupnpc_declspec.h
-    DESTINATION include/miniupnpc
-  )
-
-  install(FILES miniupnpc-config.cmake
-    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/miniupnpc
-  )
-
-  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/miniupnpc.pc
-    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
-  )
-endif()
-
-# vim: ts=2:sw=2:expandtab
