=== debian/changelog ===
miniupnpc (2.2.6-1build2) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:13:21 +0200

miniupnpc (2.2.6-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 20:23:56 +0000

miniupnpc (2.2.6-1) unstable; urgency=medium

  * New upstream release.

 -- Yangfl <mmyangfl@gmail.com>  Thu, 11 Jan 2024 00:33:37 +0800
