=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: miniupnpc
 Section: net
 Priority: optional
-Maintainer: Thomas Goirand <zigo@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Thomas Goirand <zigo@debian.org>
 Uploaders:
  Yangfl <mmyangfl@gmail.com>,
 Build-Depends:
